/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-08-01 15:32:38 UTC)
 * on 2013-08-06 at 19:11:25 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.compute.model;

/**
 * A set of instance tags.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Compute Engine API. For a detailed explanation see:
 * <a href="http://code.google.com/p/google-http-java-client/wiki/JSON">http://code.google.com/p/google-http-java-client/wiki/JSON</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class Tags extends com.google.api.client.json.GenericJson {

  /**
   * Fingerprint of this resource. A hash of the tags stored in this object. This field is used
   * optimistic locking. An up-to-date tags fingerprint must be provided in order to modify tags.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String fingerprint;

  /**
   * An array of tags. Each tag must be 1-63 characters long, and comply with RFC1035.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<java.lang.String> items;

  /**
   * Fingerprint of this resource. A hash of the tags stored in this object. This field is used
   * optimistic locking. An up-to-date tags fingerprint must be provided in order to modify tags.
   * @see #decodeFingerprint()
   * @return value or {@code null} for none
   */
  public java.lang.String getFingerprint() {
    return fingerprint;
  }

  /**
   * Fingerprint of this resource. A hash of the tags stored in this object. This field is used
   * optimistic locking. An up-to-date tags fingerprint must be provided in order to modify tags.
   * @see #getFingerprint()
   * @return Base64 decoded value or {@code null} for none
   *
   * @since 1.14
   */
  public byte[] decodeFingerprint() {
    return com.google.api.client.util.Base64.decodeBase64(fingerprint);
  }

  /**
   * Fingerprint of this resource. A hash of the tags stored in this object. This field is used
   * optimistic locking. An up-to-date tags fingerprint must be provided in order to modify tags.
   * @see #encodeFingerprint()
   * @param fingerprint fingerprint or {@code null} for none
   */
  public Tags setFingerprint(java.lang.String fingerprint) {
    this.fingerprint = fingerprint;
    return this;
  }

  /**
   * Fingerprint of this resource. A hash of the tags stored in this object. This field is used
   * optimistic locking. An up-to-date tags fingerprint must be provided in order to modify tags.
   * @see #setFingerprint()
   *
   * <p>
   * The value is encoded Base64 or {@code null} for none.
   * </p>
   *
   * @since 1.14
   */
  public Tags encodeFingerprint(byte[] fingerprint) {
    this.fingerprint = com.google.api.client.util.Base64.encodeBase64URLSafeString(fingerprint);
    return this;
  }

  /**
   * An array of tags. Each tag must be 1-63 characters long, and comply with RFC1035.
   * @return value or {@code null} for none
   */
  public java.util.List<java.lang.String> getItems() {
    return items;
  }

  /**
   * An array of tags. Each tag must be 1-63 characters long, and comply with RFC1035.
   * @param items items or {@code null} for none
   */
  public Tags setItems(java.util.List<java.lang.String> items) {
    this.items = items;
    return this;
  }

  @Override
  public Tags set(String fieldName, Object value) {
    return (Tags) super.set(fieldName, value);
  }

  @Override
  public Tags clone() {
    return (Tags) super.clone();
  }

}
